//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern double BarRatio      = 0.333333;
extern bool   ViewAsCandles = false;
extern int    WickWidth     = 1;
extern int    BodyWidth     = 2;
extern string UniqueID      = "PriceBars";
extern int    LineExtend    = 50;
extern int    LineWidth     = 0;
extern int    LineStyle     = STYLE_DOT;
extern color  LineColor     = DarkGray;

double barwu[];
double barwd[];
double barbu[];
double barbd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   int type = DRAW_NONE; if (ViewAsCandles) type = DRAW_HISTOGRAM;
   SetIndexBuffer(0,barwu); SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(1,barwd); SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,WickWidth);
   SetIndexBuffer(2,barbu); SetIndexStyle(2,type          ,EMPTY,BodyWidth);
   SetIndexBuffer(3,barbd); SetIndexStyle(3,type          ,EMPTY,BodyWidth);
   return(0);
}
int deinit() { ObjectDelete(UniqueID); return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    
      for(int i = limit; i >= 0; i--)
      {
         barwu[i] = EMPTY_VALUE;
         barwd[i] = EMPTY_VALUE;
         barbu[i] = EMPTY_VALUE;
         barbd[i] = EMPTY_VALUE;
            double range = High[i]-Low[i];
            double diffh = High[i]-Close[i];
            double diffl = Close[i]-Low[i];
               if (diffh <= range*BarRatio) 
               {
                  barwu[i] = High[i];
                  barwd[i] = Low[i];
                  barbu[i] = MathMax(Open[i],Close[i]);
                  barbd[i] = MathMin(Open[i],Close[i]);
               }
               if (diffl <= range*BarRatio) 
               {
                  barwd[i] = High[i];
                  barwu[i] = Low[i];
                  barbu[i] = MathMin(Open[i],Close[i]);
                  barbd[i] = MathMax(Open[i],Close[i]);
               }
      }
      
      //
      //
      //
      //
      //
      
      if (UniqueID!="")
      {
         ObjectCreate(UniqueID,OBJ_TREND,0,0,0,0,0);
            ObjectSet(UniqueID,OBJPROP_PRICE1,(High[1]+Low[1])/2.0);
            ObjectSet(UniqueID,OBJPROP_PRICE2,(High[1]+Low[1])/2.0);
            ObjectSet(UniqueID,OBJPROP_TIME1,Time[1]);
            ObjectSet(UniqueID,OBJPROP_TIME2,Time[1]+Period()*LineExtend*60);
            ObjectSet(UniqueID,OBJPROP_COLOR,LineColor);
            ObjectSet(UniqueID,OBJPROP_STYLE,LineStyle);
            ObjectSet(UniqueID,OBJPROP_WIDTH,LineWidth);
            ObjectSet(UniqueID,OBJPROP_RAY,false);
      }
   return(0);
}